using System;
using System.Threading;
using System.Web;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Web.Services;
using System.Web.Services.Protocols;


/// <summary>
/// Summary description for TaskService
/// </summary>
[WebService(Namespace = "http://tempuri.org/")]
[WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
public class TaskService : Microsoft.Web.Services.DataService
{
	[WebMethod]
	public int GetProgress()
	{
		string processKey = this.Context.Request.UserHostAddress;
		object progress = this.Context.Cache[processKey];
        if (progress != null)
		{
            return (int)progress;
		}
		return 0;
	}

	[WebMethod]
	public int StartTimeConsumingTask()
	{
		string processKey = this.Context.Request.UserHostAddress;
		string threadLockKey = "thread" + this.Context.Request.UserHostAddress;
		object threadLock = this.Context.Cache[threadLockKey];
		if (threadLock == null)
		{
			threadLock = new object();
			this.Context.Cache[threadLockKey] = threadLock;
		}

		// Only allow 1 running task per user.
		if (!Monitor.TryEnter(threadLock, 0))
			return -1;

        DateTime startTime = DateTime.Now;

		// Simulate a time-consuming task.
		for (int i = 1; i <= 100; i++)
		{
			// Update the progress for this task.
			this.Context.Cache[processKey] = i;
			Thread.Sleep(70);
		}

		Monitor.Exit(threadLock);

        return (DateTime.Now - startTime).Seconds;
	}
}